var objInfo = {}; //存储地图选址信息
/**
 * name 选择地点名称
 * address  选择详细地址
 * center  选择地点的经纬度   [0]: lng   [1]: lat
 */
apiready = function() {

    HeardeLoad("签到地图", "../../image/login/back.png", "30px", "30px", "保存");
    HeardeOnclick(close, "", function() {
        api.sendEvent({
            name: 'mapData',
            extra: {
                objInfo: objInfo,
            }
        });
        close();
    });
    CompatibilityIos();
    mapIod();

    //选择省份
    provinceInfo();
    $("#tipinput").focus(function() {
        $(".city").hide();
    })
    $(".select_title").click(function() {
        $(".city").toggle();
    })

    /*地图定位*/ //
    // var map, geolocation;
    // var EffectiveRange = 100; //有效范围
    // var zoom = [119.258697, 26.062027]; //中心点
    // var Jl_marker = null; //原有的定位点

    //加载地图，调用浏览器定位服务
    var markers = [];
    var map = new AMap.Map('map', {
        // resizeEnable: true,
        center: [119.296389, 26.074268],
        zoom: 14
    });


    // 地图完全加载完全
    map.on('complete', function() {
        if (api.systemType == "ios") {
            $(".amap-sug-result").addClass('top');
        } else {
            $(".amap-sug-result").css("top", "105px")
        }
        //IOS与Android 输入提示框位置
    });

    // 地图点击获取点
    map.on('click', function(e) {
        var lng = e.lnglat.getLng();
        var lat = e.lnglat.getLat();
        map.clearMap();
        getAddress(lng, lat);
    });

    //获取地图点击点地址
    function getAddress(lng, lat) {
        var lnglatXY = [lng, lat];
        var geocoder = new AMap.Geocoder({
            radius: 1000,
            extensions: "all"
        });
        geocoder.getAddress(lnglatXY, function(status, result) {
            if (status === 'complete' && result.info === 'OK') {
                geocoder_CallBack(result, lnglatXY);
            }
        });
        map.setFitView();

        function geocoder_CallBack(data, lnglatXY) {
            var data = data.regeocode;
            var name, poisName;
            var street = data.addressComponent.street;
            var streetNumber = data.addressComponent.streetNumber;
            if (street == "" || streetNumber == "") {
                poisName = data.pois[0].name + '(附近)'
            } else {
                poisName = street + streetNumber;
            }
            data.aois.length == 0 ? name = poisName :
                name = data.aois[0].name //返回地点名称
            var address = data.formattedAddress; //返回详细地址描述
            var marker = new AMap.Marker({ //加点
                map: map,
                position: lnglatXY
            });
            map.setCenter(lnglatXY);
            map.remove(markers);
            markers.push(marker);
            $("#tipinput").val(name);
            //存储选点信息
            objInfo.name = name;
            objInfo.address = address;
            objInfo.center = lnglatXY;
            console.log(JSON.stringify(objInfo));
        }
    }

    //输入提示
    var autoOptions = {
        city: '福州',
        input: "tipinput"
    };
    var auto = new AMap.Autocomplete(autoOptions);
    var placeSearch = new AMap.PlaceSearch({
        city: '福州',
        map: map,
        panel: "panel"
    }); //构造地点查询类
    AMap.event.addListener(auto, "select", select); //注册监听，当选中某条记录时会触发
    function select(e) {
        placeSearch.setCity(e.poi.adcode);
        placeSearch.search(e.poi.name, function(status, result) {
            // 查询成功时，result即对应匹配的POI信息
            placeSearch.clear();
            if (status !== 'complete') return;
            var pois = result.poiList.pois;
            for (var i = 0; i < pois.length; i += 1) {
                var marker = new AMap.Marker({
                    position: pois[i].location,
                    map: map
                });
                console.log(JSON.stringify(pois));
                marker.id = pois[i].id;
                marker.name = pois[i].name;
                marker.center = [pois[i].location.lng,pois[i].location.lat];
                marker.address = pois[i].cityname + pois[i].adname + pois[i].address;
                marker.on('click', function() {
                    var newPosition = this.center;
                    var newName = this.name;
                    //存储选点信息
                    objInfo.name = newName;
                    objInfo.address = this.address;
                    objInfo.center = newPosition;
                    $("#tipinput").val(newName);
                    map.clearMap();
                    var marker = new AMap.Marker({
                        position: newPosition,
                        map: map,
                    });
                })
            }
        })
    }
    $('#tipinput').bind('keypress', function(event) {
        console.log(1);
        var inputval = $("#tipinput").val();
        if (event.keyCode == "13") {
            //回车执行查询
            placeSearch.search(inputval, function(status, result) {
                // 查询成功时，result即对应匹配的POI信息
                placeSearch.clear();
                console.log(result);
                if (status !== 'complete') return;
                var pois = result.poiList.pois;
                for (var i = 0; i < pois.length; i += 1) {
                    var marker = new AMap.Marker({
                        position: pois[i].location,
                        map: map
                    });
                    marker.id = pois[i].id;
                    marker.name = pois[i].name;
                    marker.center = pois[i].location;
                    marker.address = pois[i].cityname + pois[i].adname + pois[i].address;
                    marker.on('click', function() {
                        var newPosition = this.center;
                        var newName = this.name;
                        //存储选点信息
                        objInfo.name = newName;
                        objInfo.address = this.address;
                        objInfo.center = newPosition;
                        console.log(this.address);
                        $("#tipinput").val(newName);
                        map.clearMap();
                        var marker = new AMap.Marker({
                            position: newPosition,
                            map: map,
                        });
                    })
                }
            })
        }
    });
    $('#tipinput').focus(function() {
        $(".city").hide();
    })
    $("#tipinput").siblings().on('click', function() {
        var inputval = $("#tipinput").val();
        placeSearch.search(inputval, function(status, result) {
            // 查询成功时，result即对应匹配的POI信息
            placeSearch.clear();
            console.log(JSON.stringify(result));
            if (status !== 'complete') return;
            var pois = result.poiList.pois;
            for (var i = 0; i < pois.length; i += 1) {
                var marker = new AMap.Marker({
                    position: pois[i].location,
                    map: map
                });
                marker.id = pois[i].id;
                marker.name = pois[i].name;
                marker.center = pois[i].location;
                marker.address = pois[i].cityname + pois[i].adname + pois[i].address;
                marker.on('click', function() {
                    var newPosition = this.center;
                    var newName = this.name;
                    //存储选点信息
                    objInfo.name = newName;
                    objInfo.address = this.address;
                    objInfo.center = newPosition;
                    $("#tipinput").val(newName);
                    map.clearMap();
                    var marker = new AMap.Marker({
                        position: newPosition,
                        map: map,
                    });
                })
            }
        })
    });
}

function mapIod() {
    var systemType = api.systemType; // 获取手机类型，比如： ios
    if (systemType == 'ios') { //兼容ios
        $("html").css("height", 'calc(100% - 70px)');
    } else {
        $("#myPageTop").css("top", "60px")
    }
}

function provinceInfo() {
    var provinceData, provinceHtml;
    for (var province in picker_json) {
        provinceData = picker_json[province].text;
        provinceHtml = `<a href="javascript:;">${provinceData}</a>`;
        $("#li_province").append(provinceHtml);
    }
    cityInfo();
}

function cityInfo() {
    var childrenObj = {};
    var cityData, provinceText, cityText;
    $("#li_province a").on('click', function() {
        $("#li_province a").removeClass('checked');
        $(this).addClass("checked");
        provinceText = $(this).text();
        $(".select_title").html(provinceText + '/');
        var cityHtml = "";
        childrenObj = picker_json[$(this).index()].children;
        for (var city in childrenObj) {
            cityData = childrenObj[city].text;
            cityHtml += `<a href="javascript:;">${cityData}</a>`;
        }
        $("#li_city").html(cityHtml);
        $("#li_city a").on('click', function() {
            $("#li_city a").removeClass('checked');
            $(this).addClass("checked");
            cityText = $(this).text();
            $(".select_title").html(provinceText + "/" + cityText);
            setTimeout(function() {
                $(".city").toggle();
            }, 300)
        })
    })
}
